#!/bin/bash

RPL=/usr/bin/rpl
CP=/bin/cp
RM=/bin/rm
USERADD=/usr/sbin/useradd
USERDEL=/usr/sbin/userdel
OPENSSL=/usr/bin/openssl
CHOWN=/bin/chown
CHMOD=/bin/chmod
MKDIR=/bin/mkdir
LN=/bin/ln
CAT=/bin/cat
ECHO=/bin/echo
MKTEMP=/bin/mktemp
PWGEN=/usr/bin/pwgen
UPDATE_RC_D=/usr/sbin/update-rc.d

####################################################################################

SOFT_NAME=litecoin-init
INITD_FILE=litecoin-init.sh
DEFAULT_FILE=litecoin-init

SYSTEM_USER=litecoin-init
RPC_USER=litecoin-init

FILE_PEM=${SOFT_NAME}.pem
FILE_CERT=${SOFT_NAME}.cert

SKEL_DIR=/usr/share/${SOFT_NAME}/skels
SYSTEM_USER_DIR=/var/lib/${SYSTEM_USER}

DAYS=4000

function renew_ssl_cert
{
    SSL_EAY_FILE=`${MKTEMP}`
    FILE_PEM_TMP=/tmp/${FILE_PEM}
    FILE_CERT_TMP=/tmp/${FILE_CERT}

    ${CP} -f ${SKEL_DIR}/ssleay.cnf ${SSL_EAY_FILE} || return $?

    if [ -f ${FILE_PEM_TMP} ]
    then
	${RM} -f ${FILE_PEM_TMP}
    fi

    if [ -f ${FILE_CERT_TMP} ]
    then
        ${RM} -f ${FILE_CERT_TMP}
    fi

    ${OPENSSL} genrsa -out ${FILE_PEM_TMP} 4096 || return $?
    ${OPENSSL} req -new -config ${SSL_EAY_FILE} -x509 -nodes -sha1 -days ${DAYS} -key ${FILE_PEM_TMP} > ${FILE_CERT_TMP} || return $?

    ${CP} -f ${FILE_PEM_TMP} /etc/${SOFT_NAME}/${FILE_PEM} || return $?
    ${CHOWN} ${SYSTEM_USER}:${SYSTEM_USER} /etc/${SOFT_NAME}/${FILE_PEM} || return $?
    ${CHMOD} 0400 /etc/${SOFT_NAME}/${FILE_PEM} || return $?

    ${CP} -f ${FILE_CERT_TMP} /etc/${SOFT_NAME}/${FILE_CERT} || return $?
    ${CHOWN} ${SYSTEM_USER}:${SYSTEM_USER} /etc/${SOFT_NAME}/${FILE_CERT} || return $?
    ${CHMOD} 0400 /etc/${SOFT_NAME}/${FILE_CERT} || return $?

    ${RM} -f ${SSL_EAY_FILE}

    if [ -f ${FILE_PEM_TMP} ]
    then
	${RM} -f ${FILE_PEM_TMP}
    fi

    if [ -f ${FILE_CERT_TMP} ]
    then
        ${RM} -f ${FILE_CERT_TMP}
    fi
}

####################################################################################

##/etc/init.d/${INITD_FILE} stop

renew_ssl_cert

##/etc/init.d/${INITD_FILE} start


